/*#######################################################################################
AVR DCF77 Clock

Copyright (C) 2006 Ulrich Radig

#######################################################################################*/

#ifndef _CLOCK_H
 #define _CLOCK_H

extern unsigned char ss;	//Globale Variable fr Sekunden
extern unsigned char mm;	//Globale Variable fr Minuten
extern unsigned char hh;	//Globale Variable fr Stunden
extern unsigned char day;	//Globale Variable fr den Tag
extern unsigned char mon;	//Globale Variable fr den Monat
extern unsigned char weekday;	//Globale Variable fr den Wochentag
extern unsigned int year;	//Globale Variable fr den Jahr

extern void Start_Clock (void); //Startet die DCF77 Uhr
extern void Add_one_Second (void);

//64 Bit fr DCF77 bentigt werden 59 Bits
extern unsigned long long dcf_rx_buffer;
//RX Pointer (Counter)
extern unsigned char rx_bit_counter;
//Hilfs Sekunden Counter
extern unsigned int h_ss;

//Interrupt an dem das DCF77 Modul hngt hier INT0
#define DCF77_INT			INT0_vect
#define TIMER_ENABLE_INT()	TIMSK |= (1<<TOIE1);

#if defined(__AVR_ATmega128__)

#define INT0_CONTROL		EICRA
#define DCF77_INT_ENABLE()	EIMSK |= (1<<INT0);

#elif defined(__AVR_ATmega32__)

#define INT0_CONTROL		MCUCR
#define DCF77_INT_ENABLE()	GICR |= (1<<INT0);

#else
#  error "Unsupported MCU type"
#endif

#define INT0_FALLING_EDGE	0x02
#define INT0_RISING_EDGE	0x03

//#define INT0_FALLING_EDGE   ((MCUCR&0xFC)|0x02)
//#define INT0_RISING_EDGE   ((MCUCR&0xFC)|0x03)

//Structur des dcf_rx_buffer
struct  DCF77_Bits {
	unsigned long long M			:1	;
	unsigned long long O1			:1	;
	unsigned long long O2			:1	;
	unsigned long long O3			:1	;
	unsigned long long O4			:1	;
	unsigned long long O5			:1	;
	unsigned long long O6			:1	;
	unsigned long long O7			:1	;
	unsigned long long O8			:1	;
	unsigned long long O9			:1	;
	unsigned long long O10		:1	;
	unsigned long long O11		:1	;
	unsigned long long O12		:1	;
	unsigned long long O13		:1	;
	unsigned long long O14		:1	;
	unsigned long long R			:1	;
	unsigned long long A1			:1	;
	unsigned long long Z1			:1	;
	unsigned long long Z2			:1	;
	unsigned long long A2			:1	;
	unsigned long long S			:1	;
	unsigned long long Min		:7	;//7 Bits fr die Minuten
	unsigned long long P1			:1	;//Parity Minuten
	unsigned long long Hour		:6	;//6 Bits fr die Stunden
	unsigned long long P2			:1	;//Parity Stunden
	unsigned long long Day		:6	;//6 Bits fr den Tag
	unsigned long long Weekday	:3	;//3 Bits fr den Wochentag 
	unsigned long long Month		:5	;//3 Bits fr den Monat
	unsigned long long Year		:8	;//8 Bits fr das Jahr **eine 5 fr das Jahr 2005**
	unsigned long long P3			:1	;//Parity von P2
	};
	
struct 
	{
	char parity_err					:1	;//Hilfs Parity
	char parity_P1					:1	;//Berechnetes Parity P1
	char parity_P2					:1	;//Berechnetes Parity P2
	char parity_P3					:1	;//Berechnetes Parity P3
	char dcf_rx						:1	;//Es wurde ein Impuls empfangen
	char dcf_sync					:1	;//In der letzten Minuten wurde die Uhr syncronisiert
	}flags;

#endif //_CLOCK_H
